﻿Imports System.Text

Public Class Form1

    ' 프레임 시작 구분코드
    Private Const STXCODE As String = "@"
    ' 프레임 종료 구분코드
    Private Const ETXCODE As String = ";"

    ' 연결된 클라이언트의 IP 주소
    Private m_strClientIPAddress As String
    ' 총 수신데이터 카운트
    Private recvTotalCnt As Integer = 0
    ' 총 수신에러 카운트
    Private recvErrorCnt As Integer = 0
    ' 송신 카운트
    Private m_iSendCnt As Integer = 0
    ' CRC32데이터
    Private m_CRC32Data As String = ""
    ' 전송데이터
    Private m_sSendData As String = ""
    Private m_strReceive As String

    Public Enum VERIFYCODE
        SUCESS = 0          ' 성공
        LENGTH_ERROR = 1    ' 길이에러
        CRC_ERROR = 2       ' CRC에러
        [ERROR] = 3         ' 그 이외 에러
    End Enum

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
        ' 현재 Form을 MainForm으로 설정합니다.
        SmartForm1.MainForm = Me
        ' 전송할 데이터의 길이를 출력
        labDataLength.Text = labSendData.Text.Length.ToString()
    End Sub

    ' 서버 시작
    Private Sub btnServerStart_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnServerStart.Click
        ' SmartFile의 경로를 설정하고 파일 Open
        SmartFile1.FilePathName = "Flash Disk\Test1.txt"
        SmartFile1.Open()

        ' SmartTCPMultiServer 초기화
        SmartTCPMultiServer1.Port = 3377
        SmartTCPMultiServer1.MaxClient = 30
        SmartTCPMultiServer1.MaxReceiveBufferSize = 500000
        SmartTCPMultiServer1.ReceiveTimeout = 3000
        ' 송신 데이터
        m_sSendData = labSendData.Text

        If SmartTCPMultiServer1.IsStart = False Then
            SmartTCPMultiServer1.Start()
        End If

        If SmartTCPMultiServer1.IsStart = True Then
            labServerStatus.Text = "시작"
        Else
            labServerStatus.Text = "시작X"
        End If
    End Sub

    ' 파일 쓰기(일괄처리)
    Private Sub btnFileWrite_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnFileWrite.Click
        SmartFile1.StringType.WriteBufferSave()
        SmartFile1.Close()
    End Sub

    ' 프로그램 종료
    Private Sub btnServerExit_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnServerExit.Click
        If SmartTCPMultiServer1.IsStart = True Then
            SmartTCPMultiServer1.Stop()
        End If

        SmartForm1.Close()
    End Sub

    ' 리스트 박스 클리어
    Private Sub btnClear_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnClear.Click
        lstRecvList.ClearAll()
    End Sub

    ' 데이터 전송
    Private Sub btnSend_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnSend.Click
        SmartTimer1.Interval = Convert.ToInt32(udInterval.Value)
        m_iSendCnt = 0
        SmartTimer1.Start()
    End Sub

    Private Sub smartTimer1_Tick(ByVal sender As Object, ByVal e As EventArgs) Handles SmartTimer1.Tick
        If udSendCount.Value < System.Threading.Interlocked.Increment(m_iSendCnt) Then
            SmartTimer1.Stop()
            m_iSendCnt = 0
        Else
            Dim StrByte As Byte() = Encoding.Unicode.GetBytes(m_sSendData)
            m_CRC32Data = SmartX.SmartTCPMultiServer.GetCRC32Gen(StrByte).ToString("X")

            ' Frame Format : STXCODE(1) + LENGTH(5) + CRC(8) + DATA(N) + ETXCODE(1)
            ' 모든 문자열은 Unicode 문자열로 처리됨
            SmartTCPMultiServer1.SendStringUnicodeIP(m_strClientIPAddress, STXCODE & m_sSendData.Length.ToString("00000") & m_CRC32Data & m_sSendData & ETXCODE)
            labSendCount.Text = (m_iSendCnt).ToString()
        End If
    End Sub

    ' 수신 이벤트
    Private Sub smartTCPMultiServer1_OnReceiveHandler(ByVal datas As SmartX.SmartTCPMultiServer.CHandleClient.READINFO) Handles SmartTCPMultiServer1.OnReceiveHandler
        ' 수신된 데이터를 Unicode형식으로 변경
        Dim strRecData As String
        ' GetFrameData에서 반환받은 프레임구조의 데이터 저장
        Dim strFrameData As String

        strRecData = SmartX.SmartTCPMultiServer.ConvertUnicodeByteToString(datas.receiveDatas)

        ' 프레임 구조가 될때까지 m_strReceive에 데이터를 누적
        m_strReceive += strRecData

        If strRecData <> "" Then
            ' m_strReceive의 데이터가 공백이 될때까지 strFrameData(STXCODE(1) + LENGTH(5) + CRC(8) + DATA(N) + ETXCODE(1))구조로 완성하여 출력
            Do
                ' GetFrameData를 호출
                strFrameData = GetFrameData(m_strReceive)
                If strFrameData <> "" Then

                    Select Case Verification(strFrameData)
                        Case VERIFYCODE.SUCESS
                            ' 정상수신
                            labSuccessCnt.Text = (System.Threading.Interlocked.Increment(recvTotalCnt)).ToString()
                            lstRecvList.AddItem("[" & recvTotalCnt.ToString() & "] " & strFrameData)
                            SmartFile1.StringType.WriteBuffer(strFrameData & vbCrLf & vbCrLf)
                        Case VERIFYCODE.CRC_ERROR
                            ' CRC 오류발생
                            labErrorCnt.Text = (System.Threading.Interlocked.Increment(recvErrorCnt)).ToString()
                            labErrorMsg.Text = "CRC_ERROR"
                        Case VERIFYCODE.LENGTH_ERROR
                            ' 수신 데이터 길이오류발생
                            labErrorCnt.Text = (System.Threading.Interlocked.Increment(recvErrorCnt)).ToString()
                            labErrorMsg.Text = "LENGTH_ERROR"
                        Case VERIFYCODE.[ERROR]
                            ' 그외 오류발생
                            labErrorCnt.Text = (System.Threading.Interlocked.Increment(recvErrorCnt)).ToString()
                            labErrorMsg.Text = "ERROR"
                    End Select
                End If
            Loop While strFrameData <> ""
        End If
    End Sub

    ' 프레임(STX+LENGTH+CRC32+데이터+ETX)구조로 만들어질 때까지 ""을 리턴하고 
    ' 프레임 구조로 만들어진 경우 해당 프레임 부분을 리턴하고 프레임을 제외한 나머지 부분은 strInData에 저장
    Private Function GetFrameData(ByRef strInData As String) As String
        ' 프레임에서 STX의 인덱스
        Dim iPosSTX As Integer
        ' 프레임에서 ETX의 인덱스
        Dim iPosETX As Integer
        ' 수신데이터
        Dim strTemp As String
        ' 리턴데이터(완전한 프레임)
        Dim strRet As String

        strTemp = strInData

        ' strTemp에서 맨 처음 발견되는 지정된 유니코드 문자('@')의 0부터 시작하는 인덱스를 iPosSTX에저장
        iPosSTX = strTemp.IndexOf(STXCODE)

        ' strTemp에서'@'를 발견하지 못한경우
        If iPosSTX = -1 Then
            Return ""
        End If

        ' strTemp에서 맨 처음 발견되는 지정된 유니코드 문자(';')의 0부터 시작하는 인덱스를 iPosETX에 저장
        iPosETX = strTemp.IndexOf(ETXCODE)

        ' strTemp에서';'를 발견하지 못한경우
        If iPosETX = -1 Then
            Return ""
        End If

        ' @와;가 모두 있어야만 이부분 실행
        ' iPosSTX 부터 (iPosETX - iPosSTX) + 1까지의 문자를 strRet에 저장
        strRet = strTemp.Substring(iPosSTX, (iPosETX - iPosSTX) + 1)

        ' iPosSTX 부터 (iPosETX - iPosSTX) + 1까지의 문자를 삭제
        ' strTemp - strRet나머지를 strInData에저장. GetFrameData(ref string strInData)호출시 인자로 전달
        strInData = strTemp.Remove(iPosSTX, (iPosETX - iPosSTX) + 1)

        ' @와;가 들어있는 완전한 프레임을 반환
        Return strRet
    End Function

    ' Frame Format : STX(1) + LENGTH(5) + CRC(8) + DATA(N) + ETX(1)
    Public Function Verification(ByVal strFrameData As String) As VERIFYCODE
        ' 데이터길이
        Dim iLength_Read As Integer
        ' 데이터길이 검증
        Dim iLength_Cal As Integer
        ' 수신프레임에서 추출된 CRC저장
        Dim strCRC_Read As String
        ' strCRC_Read(16진수) --> int형으로 변환
        Dim iCRC_Read As Integer
        ' CRC값을 계산하고 int형으로 변환
        Dim iCRC_Cal As Integer
        Dim strData As String
        Dim chData As Byte()

        Try
            ' 수신데이터에서 데이터의 길이 추출
            iLength_Read = Convert.ToInt32(strFrameData.Substring(1, 5))
            ' 수신데이터의 데이터의 길이 계산
            iLength_Cal = strFrameData.Length - 15

            If iLength_Read <> iLength_Cal Then
                ' 길이 오류
                Return VERIFYCODE.LENGTH_ERROR
            End If

            ' 수신된 데이터에서 실제데이터만 추출
            strData = strFrameData.Substring(14, strFrameData.Length - 15)

            ' CRC추출
            strCRC_Read = strFrameData.Substring(6, 8)

            ' 16진수를 int형으로 변환하여 iCRC_Read에 저장
            iCRC_Read = Convert.ToInt32(strCRC_Read, 16)

            ' String형을 Unicode타입의 Byte[]로 변환
            chData = Encoding.Unicode.GetBytes(strData)

            ' CRC값을 계산하고 Int형으로 변환하여 iCRC_Cal에 저장
            iCRC_Cal = CInt(SmartX.SmartTCPMultiServer.GetCRC32Gen(chData))
        Catch __unusedException1__ As Exception
            Return VERIFYCODE.[ERROR]
        End Try

        ' 수신데이터의 CRC32값과 계산하여 만든 CRC32값이 일치 안한다면
        If iCRC_Read <> iCRC_Cal Then
            Return VERIFYCODE.CRC_ERROR
        End If

        Return VERIFYCODE.SUCESS
    End Function

    Private Sub smartTCPMultiServer1_OnClientAdd(ByVal addClientInfo As SmartX.SmartTCPMultiServer.CLIENTSINFOS) Handles SmartTCPMultiServer1.OnClientAdd
        m_strClientIPAddress = addClientInfo.strIPAddress
    End Sub
End Class
